/**
 * Copyright (C) 2008 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.def.impl;

import java.util.HashSet;
import java.util.Set;

import org.ow2.orchestra.facade.def.ActivityDefinition;
import org.ow2.orchestra.facade.uuid.ActivityDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;

/**
 *
 * @author Gael Lalire
 */
public class ActivityDefinitionImpl extends DefinitionRecordImpl implements ActivityDefinition {

  private static final long serialVersionUID = -6522865558817129517L;

  protected Set<ActivityDefinitionUUID> enclosedActivitiesUUID;

  protected ActivityDefinitionUUID uuid;

  protected ActivityDefinitionImpl() { }

  protected ActivityDefinitionImpl(final ActivityDefinitionUUID uuid, final ProcessDefinitionUUID processDefinitionUUID,
      final String elementName, final String name) {
    super(processDefinitionUUID, elementName, name);
    enclosedActivitiesUUID = new HashSet<ActivityDefinitionUUID>();
    this.uuid = uuid;
  }

  public ActivityDefinitionImpl(final ActivityDefinition src) {
    super(src);
    enclosedActivitiesUUID = new HashSet<ActivityDefinitionUUID>(src.getEnclosedActivitiesUUID());
    uuid = src.getUUID();
  }

  public Set<ActivityDefinitionUUID> getEnclosedActivitiesUUID() {
    return enclosedActivitiesUUID;
  }

  public ActivityDefinitionUUID getUUID() {
    return uuid;
  }

}
