/**
 * Copyright (C) 2008 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.facade.def.impl;

import java.util.HashSet;
import java.util.Set;

import org.ow2.orchestra.facade.def.ActivityFullDefinition;
import org.ow2.orchestra.facade.uuid.ActivityDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;

/**
 *
 * @author Gael Lalire
 */
public class ActivityFullDefinitionImpl extends ActivityDefinitionImpl implements ActivityFullDefinition {

  private static final long serialVersionUID = 915442518888861862L;

  protected Set<ActivityFullDefinition> enclosedActivities;

  protected ActivityFullDefinitionImpl() {
    super();
  }

  public ActivityFullDefinitionImpl(final ActivityDefinitionUUID uuid,
      final ProcessDefinitionUUID processUUID, final String elementName, final String name) {
    super(uuid, processUUID, elementName, name);
    enclosedActivities = new HashSet<ActivityFullDefinition>();
  }

  public void addEnclosedActivity(final ActivityFullDefinition enclosedActivity) {
    enclosedActivities.add(enclosedActivity);
    enclosedActivitiesUUID.add(enclosedActivity.getUUID());
  }

  public Set<ActivityFullDefinition> getEnclosedActivities() {
    return enclosedActivities;
  }

}
