/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.persistence;

import java.util.Set;

import org.jbpm.pvm.session.DbSession;
import org.ow2.orchestra.facade.runtime.ActivityFullInstance;
import org.ow2.orchestra.facade.runtime.ActivityState;
import org.ow2.orchestra.facade.runtime.ProcessFullInstance;
import org.ow2.orchestra.facade.runtime.ProcessState;
import org.ow2.orchestra.facade.uuid.ActivityInstanceUUID;
import org.ow2.orchestra.facade.uuid.ProcessDefinitionUUID;
import org.ow2.orchestra.facade.uuid.ProcessInstanceUUID;

/**
 *
 * @author Gael Lalire
 */
public interface QuerierDbSession extends DbSession {

  // Querier : Process

  Set<ProcessFullInstance> findProcessInstance();

  Set<ProcessFullInstance> findProcessInstance(final ProcessDefinitionUUID processDefinitionUUID);

  Set<ProcessFullInstance> findProcessInstance(final ProcessDefinitionUUID processDefinitionUUID,
      final ProcessState processState);

  Set<ProcessFullInstance> findProcessInstance(final ProcessState processState);

  // Querier : Activity

  Set<ActivityFullInstance> findActivityInstance(final ProcessInstanceUUID processUUID);

  Set<ActivityFullInstance> findActivityInstance(final ProcessInstanceUUID processUUID, final ActivityState activityState);

  // Finder

  ProcessFullInstance getProcessInstance(final ProcessInstanceUUID processInstanceUUID);

  ActivityFullInstance getActivityInstance(final ActivityInstanceUUID activityInstanceUUID);

}
