/**
 * Copyright (C) 2008 Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/

package org.ow2.orchestra.services.handlers.impl;

import java.util.Iterator;
import java.util.List;

import org.ow2.orchestra.facade.data.ProcessInstanceData;
import org.ow2.orchestra.runtime.BpelExecution;
import org.ow2.orchestra.services.handlers.FinishedInstanceHandler;
import org.ow2.orchestra.services.itf.Repository;
import org.ow2.orchestra.util.EnvTool;

public class DeleteFinishedInstanceHandler implements FinishedInstanceHandler {

  public void handleFinishedInstance(final ProcessInstanceData processInstanceData) {

    final Repository repository = EnvTool.getRepository();
    final List<BpelExecution> bpelList = repository.getInstances(processInstanceData.getProcessDefinitionData().getQName());

    // Get the processInstance ended
    Iterator<BpelExecution> bpelIterator = bpelList.iterator();
    while (bpelIterator.hasNext()) {
      BpelExecution bpelExecution = bpelIterator.next();
      if (bpelExecution.getProcessInstance().getProcessInstanceUUID().equals(processInstanceData.getUUID())) {
        repository.removeInstance(bpelExecution);
        break;
      }
    }
  }
}
